        


C---------------------------------------------------------------
C
C      SUBROUTINE ERESADD:
C
C                  GIVEN IT, K, ADDES  TO PSI_E (== PSI_RESOLV)
C                               THE   CONTRIBUTION FROM psi_k
C                  Note that K can be zero (modifciation)
C---------------------------------------------------------------

      SUBROUTINE ERESADD_new( 
     x energy, ne, ntot, ktop, psi_k, k, psi_resolv, cecof,tmin)
      
      implicit none
      
      integer     ne, ntot, ktop, ie, k
      complex*16, parameter :: ci=(0.d0, 1.d0)
      
      complex*16  psi_k(ntot)
      complex*16  PSI_RESOLV(ntot, ne)
      complex*16  CECOF(NE, 0:ktop)
      complex*16  CSUB, CJUNK
      real*8      ENERGY(NE)
      real*8      tmin
      
      DO IE=1,NE
         CSUB = EXP(CI*(ENERGY(IE) )*tmin)
         CJUNK = CSUB* CECOF(IE,K)
         Psi_resolv(:, ie) = Psi_resolv(:, ie) + CJUNK*Psi_k(:)
      ENDDO

      


      END
CP--------------------------------------------------------------------
C SUBROUTINE RESCOPRE: CALLS AND CHECKS COEFF. OF 
C            ENERGY RESOLUTION.
C--------------------------------------------------------------------
      SUBROUTINE RESCOPRE_NEW(NE,ENERGY,KTOP, CECOF, DT, EBAR, DE)

      IMPLICIT REAL*8 (A-B,D-H,O-Z)
      IMPLICIT COMPLEX*16 (C)
      DIMENSION CECOF(NE,*), ENERGY(NE)
      complex*16, dimension(:,:), allocatable :: cedummy
      allocate( cedummy(ne, ktop+10), stat=ierr)
      if(ierr/=0) then
         write(6,*)' problem in cedummy ; ierr = ',ierr
         stop
      endif

      ci = (0.d0,1.d0)

      CALL RESCO( NE, ENERGY, KTOP+1, CECOF, CEDUMMY,
     1            DT, EBAR, DE, 2000)

      WRITE(6,*)' ---------- NOW CHECK RESCO------'

      DO 666 IE=1,NE
             CSMRES=0.D0
             DO 6662 IBES=1,KTOP+1
6662             CSMRES=CSMRES+CECOF(IE,IBES)    
                 ECHK= ENERGY(IE)-EBAR-DE
                 CEINT= 1.D0/(CI*ECHK)*(EXP(CI*ECHK*DT)-1)
                 
                 WRITE(6,*)' RES_SUM  ',CSMRES
                 WRITE(6,*)' RES_CHK  ',CEINT,' enrgy',ENERGY(IE)
                 if(abs(CSMRES-CEINT)>1.d-7) stop
666    CONTINUE                 

       END
C---------------------------------------------------------------
C         
C  RESCO: SEE "RESCOF". RESCO CALLS 
C         RESCOF TWICE, TO CHECK CONVERGENCE ( W.R.T INTEGRATION)
C
C THE INPUT TIMES MUST BE IN 1/EV UNITS. SCALE  !!
C---------------------------------------------------------------

           SUBROUTINE 
     .     RESCO(NE,E,NBES,ECOF,EDUMMY,DELTAT,EBAR,DE,NINTG)

           IMPLICIT REAL*8(A-H,O-Y)
           IMPLICIT COMPLEX*16(Z)

           COMPLEX*16 ECOF(NE,NBES),EDUMMY(NE,NBES),I,Z

           REAL*8 E(NE)


           CALL       RESCOF(NE,E,NBES,ECOF  ,DELTAT,EBAR,DE,NINTG*4)
           CALL       RESCOF(NE,E,NBES,EDUMMY,DELTAT,EBAR,DE,NINTG*2)

           DO 1 IE=1,NE
           DO 1 IBES=1,NBES

              Z2 = ECOF(IE,IBES)
              Z3 = EDUMMY(IE,IBES)
              XD = abs(Z2-Z3)**2
              IF(XD.GT.1.D-12) THEN
                 
                   WRITE(6,*)' PROBLEM IN RESCOF. IE,IBES',IE,IBES
                   WRITE(6,*)   ECOF(IE,IBES),EDUMMY(IE,IBES)
                   WRITE(6,*)' Z2-Z3 ',ABS(Z2-Z3)
                   WRITE(6,*)' XD, Z2, Z3 ',XD,Z2,Z3
                   STOP

              
              ENDIF
1          CONTINUE
           END


C------------------------------------------------------------
C  RESCOF: ECOF(IE,IBES)= INT_0^DELTAT J_IBES(T/2*(EMAX-EMIN))*
C                                        EXP(I*(E(IE)-E_AVG)*T) * DT
C
C            * (-I) ???**N * (2-DELTA_N,0)  
C-------------------------------------------------------------

            
           SUBROUTINE RESCOF(NE,E,NBES,ECOF,DELTAT,EBAR,DE,NINTG)

              IMPLICIT REAL*8(A-H,O-Y)
              IMPLICIT COMPLEX*16(Z)
                
              COMPLEX*16 ECOF(NE,NBES),I,Z
             
              PARAMETER(NBESMX=5000)

              REAL*8 BESARR(NBESMX),E(NE)

              DATA I /(0.D0,1.D0)/

              IF(NBES.GE.NBESMX) THEN
                     WRITE(6,*)' NBES>=NBESMX',NBES,NBESMX
                     STOP
              ENDIF

              DT=(1.D0)/NINTG*DELTAT 


              DO 1 J=0,NINTG
              
                   T=DT*J+1.E-20
                   
                   IF(    J.EQ.0.OR.J.EQ.NINTG)  THEN
                     WGHT = DT/3.D0
                   ELSE IF(MOD(J,2).EQ.0) THEN
                     WGHT = DT/3.D0*2
                   ELSE IF(MOD(J,2).EQ.1) THEN
                     WGHT = DT/3.D0*4
                   ENDIF
                   
                   
!!                 Call bessel_real_array_sub(besarr, nbes, t*de)
                   CALL MMBSJN(T*DE,NBES,BESARR,IER)
                   call check(ierr,0,' ierr ')
        
                   DO 1 IE=1,NE
                      Z = EXP(I*(E(IE)-EBAR)*T)
                      DO 1 IBES=1,NBES
                         
                         IF(J.EQ.0) ECOF(IE,IBES) = 0.D0
                
                         ECOF(IE,IBES) = 
     .                   ECOF(IE,IBES) + BESARR(IBES)*WGHT*Z 
                       
1              CONTINUE

          DO 8 IE=1,NE
          DO 8 IBES=1,NBES
          
          DELTA0 = 0.D0
          IF(IBES.EQ.1) DELTA0=1 

          ECOF(IE,IBES) = ECOF(IE,IBES) *(2-DELTA0)* (-I)**(IBES-1)

8         CONTINUE
          


           END
