      subroutine c_symm_tridiag_lot(off_diag, diag, r, u, n, lot)
      implicit none

      integer n,j,lot
      
      complex*16 bet
      complex*16 off_diag(n-1),diag(n),r(n,lot),u(n,lot)!could be off_diag(n)
      complex*16, allocatable, dimension(:) :: gam
      allocate(gam(n), stat=j);if(j/=0)stop

      if(abs(diag(1))==0.d0)then
         write(6,*)' problem, diag(1) ',diag(1)
         stop
      endif

      bet=diag(1)
      u(1,:)=r(1,:)/bet
      do 11 j=2,n
        gam(j)=off_diag(j-1)/bet
        bet=diag(j)-off_diag(j-1)*gam(j)
        if(bet.eq.0.)pause
        u(j,:)=(r(j,:)-off_diag(j-1)*u(j-1,:))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j,:)=u(j,:)-gam(j+1)*u(j+1,:)
12    continue
      deallocate(gam)
      end

      subroutine c_tridag(a,b,c,r,u,n)
      implicit none

      integer n,j
      integer, parameter :: nmax=100
      
      complex*16 bet
      complex*16 gam(nmax),a(n),b(n),c(n),r(n),u(n)

      if(b(1)==0.d0.or.n>nmax)then
         write(6,*)' problem, b(1),n,nmax ',b(1),n,nmax
         stop
      endif

      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(bet.eq.0.)pause
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      end

      subroutine r_tridag(a,b,c,r,u,n)
      implicit none

      integer n,j
      integer, parameter :: nmax=100
      
      real*8 bet
      real*8 gam(nmax),a(n),b(n),c(n),r(n),u(n)

      if(b(1)==0.d0.or.n>nmax)then
         write(6,*)' problem, b(1),n,nmax ',b(1),n,nmax
         stop
      endif

      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(bet.eq.0.)pause
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      end










