!
! Part 4:
!
! Now you'll do exercises.  You'll need to modify the routine to:
!
!
!  (i) Use different functions instead of the gaussian, e.g., cos or a more
!  complicated functions -- make sure you also calculate the numerical
!  derivative. 
!
!  When you run, note how the accuracy is proportional to dx until
!  dx is very small, and then it degrades  Make sure you understand why.
!
!  (ii) Modify the
!   program to do the following:
!
!      (ii.1): first, calculate the first derivative also from
!              the symmetric expression for the first derivative:
!               df/dx = (f(x+dx)-f(x-dx))/2/dx, and compare to the Euler
!               expression
! 
!      (ii.2) Calculate 2'nd derivatives, based on the expression:
!                   f' ~(f(x+dx)-2f(x)+f(x-dx))/dx**2
!
!           We'll derive this expression in class,based on Taylor expansions.
!


program main
  implicit none         

  real*8 x          
  real*8 dx         
  real*8 fx         
  real*8 fxpr       
  real*8 fxdrv_a    
  real*8 fxdrv_a_pr 
  real*8 fx_num_E1  
           
  integer j          
                     
  
  x  = 0.3   
  
  print *,' dx,  df/dx(Euler) - df/dx(Analytical) '   

  do j=1,20
            
     dx = 10.d0**(-dble(j))       
                                  

     call gauss_sub(x,    fx,   fxdrv_a)   
     call gauss_sub(x+dx, fxpr, fxdrv_a_pr)
     
     fx_num_E1 = (fxpr-fx)/dx      
     
     write(6,'(d15.5,d17.5)')  dx,  fx_num_E1   - fxdrv_a   ! see below
  enddo
end  


subroutine gauss_sub(x, fx, fxdrv_a)
  implicit none

  real*8 x, fx, fxdrv_a

  fx      =      exp(-x**2/2)     
  fxdrv_a = -x*  exp(-x**2/2)     

end subroutine gauss_sub






